//+------------------------------------------------------------------+ 
//|   TRO2009_PLOT                                                   | 
//|                                                                  | 
//|   Copyright  2009, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 
//| Use http://therumpledone.mbtrading.com/fx/ as your forex broker  |  
//| ...tell them therumpledone sent you!                             |  
//+------------------------------------------------------------------+ 
#property  copyright "Copyright  2009, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 
 

#property indicator_chart_window

extern int    myShift       = 0 ;  

extern int    Line_Style_Open    = STYLE_DASHDOT ;
extern int    Line_Style_High    = STYLE_SOLID ;
extern int    Line_Style_Low     = STYLE_SOLID ;
extern int    Line_Style_Close   = STYLE_SOLID ;
extern int    Line_Style_Mid     = STYLE_DOT ;
extern int    Line_Style_Pivot   = STYLE_DASH ;


extern int    Line_Width_Open    = 2 ;
extern int    Line_Width_High    = 3 ;
extern int    Line_Width_Low     = 3 ;
extern int    Line_Width_Close   = 2 ;
extern int    Line_Width_Mid     = 1 ;
extern int    Line_Width_Pivot   = 1 ;

extern bool plot.Open  = true ;
extern bool plot.High  = true ;
extern bool plot.Low   = true ;
extern bool plot.Close = true ;
extern bool plot.Mid   = true ;
extern bool plot.Pivot = true ;



extern bool show.M1  = false ;
extern bool show.M5  = false ;
extern bool show.M15 = false ;
extern bool show.H1  = true ;
extern bool show.H4  = false ;
extern bool show.D1  = true ;
extern bool show.W1  = true ;
extern bool show.MN1 = true ;


extern color color_M1  = Yellow ;
extern color color_M5  = Orange ;
extern color color_M15 = Red ;
extern color color_H1  = Bisque ; 
extern color color_H4  = Pink ;
extern color color_D1  = White ; 
extern color color_W1  = PaleGreen ;
extern color color_MN1 = DodgerBlue ;

string lbl[15], lbl2[15];
int n, j, i ;

string symbol, tChartPeriod, ShortName ;  

int    digits, period, win ; 

double point ;

double      high, low, open, close, mid, pivot  ;
 
      
//+------------------------------------------------------------------+

int init()
{
   period = Period() ;

   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   ShortName    =  "trohl-" + symbol + myShift   ;


   if(digits == 5 || digits == 3) { digits  = digits - 1 ; point = point * 10 ; }  
   
   ObDeleteObjectsByPrefix(ShortName);    
 
   return(0);
  }

//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  }
     
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix(ShortName);    
    
return(0);
}
  
//+------------------------------------------------------------------+
int start()
{

n       = 10;
 
j       = 0 ;
 


if( show.M1 )  DoLabel( PERIOD_M1 , color_M1 ) ;
if( show.M5 )  DoLabel( PERIOD_M5 , color_M5 ) ;
if( show.M15 ) DoLabel( PERIOD_M15 , color_M15 ) ;
if( show.H1 )  DoLabel( PERIOD_H1 , color_H1 ) ;
if( show.H4 )  DoLabel( PERIOD_H4 , color_H4 ) ;
if( show.D1 )  DoLabel( PERIOD_D1 , color_D1 ) ;
if( show.W1 )  DoLabel( PERIOD_W1 , color_W1 ) ;
if( show.MN1 ) DoLabel( PERIOD_MN1 , color_MN1 ) ;

return(0);
}
 

//+------------------------------------------------------------------+
 
 
void DoLabel( int wPeriod , color wColor)
{

   open  = iOpen(symbol,wPeriod,myShift); 
   high  = iHigh(symbol,wPeriod,myShift);  
   low   = iLow(symbol,wPeriod,myShift); 
   close = iClose(symbol,wPeriod,myShift);   
    
   mid   = (high+low)*0.50;
   mid   = NormalizeDouble(mid,digits);
   
   pivot = (high+low+close)*0.33333;   
   pivot = NormalizeDouble(pivot,digits);   
   
if(plot.Open)
{
   j       = j + 1 ;
   lbl[j]  = ShortName+"OP"+wPeriod+j;
   drawLine(open ,lbl[j], wColor , Line_Style_Open, Line_Width_Open ) ;
}

if(plot.High)
{
   j       = j + 1 ;
   lbl[j]  = ShortName+"HI"+wPeriod+j;
   drawLine(high ,lbl[j], wColor , Line_Style_High, Line_Width_High  ) ; 
}

if(plot.Low)
{ 
   j       = j + 1 ;
   lbl[j]  = ShortName+"LO"+wPeriod+j;
   drawLine(low ,lbl[j], wColor , Line_Style_Low, Line_Width_Low  ) ; 
}


if(plot.Close)
{
   j       = j + 1 ;
   lbl[j]  = ShortName+"CL"+wPeriod+j;
   drawLine(close ,lbl[j], wColor , Line_Style_Close, Line_Width_Close  ) ;
}

if(plot.Mid)
{
   j       = j + 1 ;
   lbl[j]  = ShortName+"MP"+wPeriod+j;
   drawLine(mid ,lbl[j], wColor , Line_Style_Mid, Line_Width_Mid  ) ;
}
  
if(plot.Pivot)
{
   j       = j + 1 ;
   lbl[j]  = ShortName+"PP"+wPeriod+j;
   drawLine(pivot ,lbl[j], wColor , Line_Style_Pivot, Line_Width_Pivot  ) ;
}
}
 

//+------------------------------------------------------------------+
 
void drawLine(double lvl,string name, color Col,int type, int Line_Width)
{
         if(ObjectFind(name) != 0)
         {
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            

            ObjectSet(name, OBJPROP_STYLE, type);

            
            ObjectSet(name, OBJPROP_COLOR, Col);
            ObjectSet(name,OBJPROP_WIDTH,Line_Width);
            
         }
         else
         {
            ObjectDelete(name);
            ObjectCreate(name, OBJ_HLINE, 0, Time[0], lvl,Time[0],lvl);
            
            ObjectSet(name, OBJPROP_STYLE, type);
            
            ObjectSet(name, OBJPROP_COLOR, Col);        
            ObjectSet(name,OBJPROP_WIDTH,Line_Width);
          
         }
 
}
 
//+------------------------------------------------------------------+
/*

Comment(

"ind_bufferOp[0]" , ind_bufferOp[0] , "\n" ,   
 

"") ; 
*/