//+------------------------------------------------------------------+ 
//|   TRO_DRAGON_MONEY_MGMT                                          | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+  
 
// http://forums.babypips.com/show-me-money-daytrading/16021-never-lose-again-150.html#post71695

//----
#property indicator_chart_window

extern int myChartX   = 500 ;
extern int myChartY   = 0 ;
extern int myCorner   = 0 ;
extern string myFont  = "Courier New" ;
extern int myFontSize = 12 ;
extern color colorHead  = DimGray ;
   
extern bool      use.actual.balance  = false ; 
extern double    myAccountSize       = 0 ;
extern double    myStopLossPips      = 20 ;
extern double    myMultiplier1       = 10 ;
extern double    myMultiplier2       = 2  ;
extern double    myLotValue          = 10000 ;
extern double    myRiskPct           = 5 ;

string symbol, tChartPeriod, ShortName ;  

int     digits, period, win, digits2, n, j, i, k ; 
 

double point, point2, value , AccountSize, PipValue,  LotSize, RiskPct, Risk ;
string lbl[15], lbl2[15];

 
//---- PipsToOpen
string Indicator_Name = "DRAGONMM:" ;
int Objs = 0;

//+------------------------------------------------------------------+ 
int     ind_bufferOp[] ;
string shortName ;
int    cpairsLenH;
int    cpairsLenV;
int    shortLength;
int    ctimesLen;
string cpairsh[];
string cpairsv[];
int    aTimes[];
string addition  = "";
string pArrow[5] ;
color  pColor[5] ;
 
string ArrowHeadRt =  "" ; // 216 up arrow head
string ArrowHeadUp =  "" ; // 217 up arrow head
string ArrowHeadDn =  "" ; // 218 up arrow head 
 

string ArrowN  = ""; // NORTH
string ArrowNE = "";  // NORTHEAST
string ArrowE  = "";  // EAST
string ArrowSE = "";  // SOUTHEAST
string ArrowS  = "";  // SOUTH
 
string D1Arrow ; 
color  D1Color ; 


int ArrowNumber[5]; 
 
double open, close, diff, spread, DailyOpen, AmountPerPip ; 
 
color PriceColor ; 
 
double MODETICKVALUE , TICKVALUE, xvalue , yvalue;    
 
int x001, x002, x003, x004, x005, x006, x007 ; 
int FillAmt = 16 ;
 
//+------------------------------------------------------------------+
int init()
  {
  
   period = Period() ; 
   
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
   ShortName    =  "DragonMM " + tChartPeriod     ;
   win          =  0 ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; } else { digits2 = 0 ; }



if( myCorner == 0 || myCorner == 2 )
{ 
   x001 = 0 ;
   x002 = 0 ;
   x003 = 70 ; 
   x004 = 90;
   x005 = 100 ;
   x006 = 90 ;  
   x007 = 90 ;     
}
else
{
   x001 = 0 ;
   x002 = 190 ; // pair
   x003 = 170 ;  // arrow
   x004 = 10 ;   // message
   x005 = 10 ;
   x006 = 10 ;  
   x007 = 10 ;   
}
 


   deinit();

 
   return(0);
  }

  
//+------------------------------------------------------------------+

void ObDeleteObjectsByPrefix(string Prefix)
  {
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal())
     {
       string ObjName = ObjectName(i);
       if(StringSubstr(ObjName, 0, L) != Prefix) 
         { 
           i++; 
           continue;
         }
       ObjectDelete(ObjName);
     }
  } 
//+------------------------------------------------------------------+
int deinit()
{
 
   ObDeleteObjectsByPrefix("DragonMM");   
    
 
   return(0);
}
 
//+------------------------------------------------------------------+
int start()
{

n       = 10;
 
j       = 0 ;


lbl[j]  = ShortName+j;
lbl2[j] = "DRAGON MONEY MANAGEMENT"   ;
DoShowHead(j, colorHead);
 
DoCalcs() ; 
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = symbol + " " + DoubleToStr(Close[0],digits)  + " D1 " + DoubleToStr(diff,0) ;
DoShowHead(j, PriceColor);  
 

j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("TickValue $", FillAmt) + DoubleToStr(MODETICKVALUE,2) ;
DoShowHead(j, colorHead);  

j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Lot Value $", FillAmt) + DoubleToStr(myLotValue,0) ;
DoShowHead(j, colorHead);   
  
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Acct Size ", FillAmt) + DoubleToStr(AccountSize,2) ;
DoShowHead(j, Lime); 
   
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Stop Loss ", FillAmt) + DoubleToStr(myStopLossPips,2) ;
DoShowHead(j, Red); 
 
 
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Risk %", FillAmt) + DoubleToStr(RiskPct,2) + "%" ;
DoShowHead(j, Red); 

 
j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Risk $", FillAmt) + DoubleToStr(Risk ,2) ;
DoShowHead(j, Red); 

j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("Lot Size", FillAmt) + DoubleToStr(LotSize,2) ;
DoShowHead(j, Orange); 
 

j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = fFill("$/Pip $", FillAmt) + DoubleToStr(AmountPerPip,2) ;
DoShowHead(j, Orange); 
 

WindowRedraw() ;   

   return(0);
}
//+------------------------------------------------------------------+
  
void DoShowHead( int u, color dsColor  )
{

string sSH001;

sSH001  = fFill(lbl2[u], 30) ;

ObjectCreate(lbl[u],23,0,Time[0],PRICE_CLOSE);
ObjectSet(lbl[u], OBJPROP_CORNER, myCorner );
ObjectSet(lbl[u],OBJPROP_XDISTANCE, x001+myChartX);
ObjectSet(lbl[u],OBJPROP_YDISTANCE,n+myChartY);
ObjectSetText(lbl[u],sSH001,myFontSize,myFont,dsColor);


n = n+20;


  }  

//+------------------------------------------------------------------+
  
void DoCalcs()
{
RefreshRates();   

yvalue        =  MarketInfo(symbol,MODE_TICKVALUE) ;

TICKVALUE     =  ( myLotValue  / yvalue ) / 1000  ; 

xvalue        =  myLotValue / 100000.00 ;

MODETICKVALUE =  yvalue * xvalue ; 


if( use.actual.balance == true )  {AccountSize = AccountBalance() ; } 
else { if( myAccountSize == 0 ) { AccountSize = myStopLossPips * myMultiplier1 * myMultiplier2  ; } 
       else {AccountSize = myAccountSize  ;}
     }  


   close = iClose(symbol,PERIOD_D1,0);   
   open  = iOpen(symbol,PERIOD_D1,0);  
   diff  = (close - open) / point ;   
   
   if(close > open ) { PriceColor = Lime ;   } else {
   if(close < open ) { PriceColor = Red ;    } else { 
                       PriceColor = Yellow ; } } 

if( myRiskPct == 0 ) { RiskPct = 100 * ( myStopLossPips * LotSize * MODETICKVALUE ) / AccountSize ; } else { RiskPct = myRiskPct ; }

Risk    = (RiskPct * AccountSize) / 100  ;


// LotSize = AccountSize / (myStopLossPips * myMultiplier1 * myMultiplier2 ) ; 

/*
LotSize = ( 1 / MODETICKVALUE ) * Risk / myStopLossPips ;
AmountPerPip = LotSize * MODETICKVALUE ;
*/

LotSize = ( 1 / TICKVALUE ) * Risk / myStopLossPips ;
AmountPerPip = LotSize * TICKVALUE ;
 

} // void 

//+------------------------------------------------------------------+ 140 - 144
void drawLabel(string name,double lvl,color Color)
{
    if(ObjectFind(name) != 0)
    {
        ObjectCreate(name, OBJ_TEXT, 0, Time[10], lvl);
        ObjectSetText(name, name, myFontSize, myFont , EMPTY);
        ObjectSet(name, OBJPROP_COLOR, Color);
    }
    else
    {
        ObjectMove(name, 0, Time[10], lvl);
    }
}


//+------------------------------------------------------------------+

string fFill(string filled, int f ) 
{
   string FILLED ;
   
   FILLED = StringSubstr(filled + "                                         " ,0,f) ;
   
return(FILLED);
}
     
  
//+------------------------------------------------------------------+
string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}

 

//+------------------------------------------------------------------+ 
/*

Comment(

"pair " , doSymbol , "\n" , 
"DailyOpen " , DoubleToStr(DailyOpen,Digits) , "\n" ,
 

"") ; 


j       = j + 1 ;
lbl[j]  = ShortName+j;
lbl2[j] = "Pip Value " + DoubleToStr(PipValue,2) ;
DoShowHead(j, colorHead); 



Here is my money management. The strategy i use to make a lot of money.
I know you guys buy and sell mini,micro and maybe standard lots.

My platform is much easier. I allready posted a few times my platform screen.

The only thing i have to do is push buy or sell, that's it. I can set SL and TP and that is all i can do.

If you have practiced wathever strategy, you have to do some calculations. I am going to tell you my calculation for the TRO DYNAMIC SR strategy. I am able to make a lot of trades in short times, i have shown you.
My average SL is 20 pip. I can NOT make (i believe in myself)10 losers in a row. I take 10 times 20 pips is my max drawdown. That would be 200 pip.
Take that number and multiply by two=400. Then you take your pipvalue. Let's take 1euro (Euro zone). Now you have your starting money.

Start with 400 eur. When you lose 10 times in a row what i think it is impossible, then you still have the half of your money.

This is the best part. Every time you score 400 pip you raise your pipvalue with 1 and so on and on. So you will be able to play with 10000 euro with a pipvalue of 50 euro. If you can manage what i do you are able to make 25000 euro with just 500 pips. I have shown you can do that in just a few days. It is not luck, you have to SEE what TRO learned me to SEE.

I know some people are talking about money managemant and the 2% rule. I told you before if you know how to handle things and you have enough back up to believe in yourself you can create your own rules. I mean trading must working for you if not keep practicing untill you do.

This method is about in and out the market as quick as you can. Other methods can't have my management rule because you will be wiped as quick as you start trading. This is working for me. If you try it it is at your own risk. The most important thing is that when you are losing: cut off asap.

This is how it wil look in numbers and when you don't lose.
start 400 gain 400 pivalue 1euro
800 400 2
1200 400 3
and so on.

About my SL. Most of it i trade without BUT i use a disaster and that is the one i set and is 50 pip. But when the market is against you and the bigger picture is not wright then i close my trade manual around -20 pip. Always put a disaster SL because when you have wathever problem you can whiped out very quick.

*/